using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
#if UNITY_EDITOR
using UnityEditor;
using UnityEditor.SceneManagement;
#endif
using UnityEngine;
using UnityEngine.Rendering;
using UnityEngine.SceneManagement;

public class OCBatchScript : OCBase
{
#if UNITY_EDITOR
    public static bool isBaking = false;
    public static bool isLM = false;

    [ContextMenu("Bake All")]
    public static void StartBake()
    {
        string[] myArray = new string[1] { "Simple Bake All" };
        isLM = true;
        args = myArray;
        Bake();
    }
    public static void StartBakeNoLm()
    {
        isLM = false;
        string[] myArray = new string[1] { "nolm" };
        args = myArray;
        Bake();
    }
    public static void Bake()
    {
        ClearScene(); 
        ClearProject();
        MoveProjectFiles();
        BakeProject();
    }
    public static void CreateEmptyScene()
    {
         EditorSceneManager.NewScene(NewSceneSetup.EmptyScene);

        //     
        foreach (var gameObject in SceneManager.GetActiveScene().GetRootGameObjects())
        {
            GameObject.DestroyImmediate(gameObject);
        }
    }

    public static string[] args;
    static void ClearScene()
    {
        //OCTools.DeleteBuildsInDirectory("Assets");
        AssetDatabase.Refresh(); //  ,   
        GameObject[] GameObjects = (FindObjectsOfType<GameObject>() as GameObject[]);

        for (int i = 0; i < GameObjects.Length; i++)
        {
            DestroyImmediate(GameObjects[i]);
        }
       }
    static void ClearProject()
    {
        //string[] GUIDS = AssetDatabase.FindAssets("t:Model");
        //foreach (string guid in GUIDS)
        //{
        //    string path = AssetDatabase.GUIDToAssetPath(guid);
        //    if (AssetDatabase.LoadAssetAtPath<OneClickSceneManager>(path) != null)
        //    {
        //     //   AssetDatabase.DeleteAsset(path);
        //    }
        //    else Logger.Log("Error Baking mode, no such file: " + path + Logger.Version);
        //}
    }
    static void MoveProjectFiles()
    {
        //if (Directory.Exists(args[0]))
        //{
        //    Directory.Move(args[0], Application.persistentDataPath);
        //}
    }
    static void BakeProject()
     {
        string[] GUIDS = AssetDatabase.FindAssets("t:Model");
        foreach (string guid in GUIDS)
        {
            string path = AssetDatabase.GUIDToAssetPath(guid);
            if (AssetDatabase.LoadAssetAtPath<OneClickSceneManager>(path) != null)
            {

                isBaking = true;
                
                CreateEmptyScene();

                GameObject GO= Instantiate(AssetDatabase.LoadAssetAtPath<OneClickSceneManager>(path).gameObject);
                GO.name=OCTools.CheckClone(GO.name);

               

                FindObjectOfType<OneClickSceneManager>().enabled = true; 
                FindObjectOfType<OneClickSceneManager>().BakeLightingAfterImport = isLM;// fix this next commit please 

                if(args.Length>0)
                if (args[0].ToLower() == "nolm")
                {
                    FindObjectOfType<OneClickSceneManager>().BakeLightingAfterImport = false;
                    Logger.Log("Import FBX to Scene with ARGS: NoLightmaps");

                }
                else
                {
                    Logger.Log("Import FBX to Scene with NO ARGS! "+ args[0]);
                }
                Logger.Log("START IMPORT! " + args[0]);
                FindObjectOfType<OneClickSceneManager>().CheckReady(); 

            }
        }
    }
#endif
}
