using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class OCCamera : MonoBehaviour
{
    [SerializeField] public OCObject ocObject;
   
    [ContextMenu("Set Camera")]
    public void SetCamera(OCObject oco)
    {
        ocObject = oco;
        Camera Cam =  GetComponent<Camera>();
        SetTransformFromJSON();
        SetSkyBox();

#if UNITY_PIPELINE_URP
        UnityEngine.Rendering.Universal.UniversalAdditionalCameraData uac = Cam.GetComponent<UnityEngine.Rendering.Universal.UniversalAdditionalCameraData>();
        if (uac == null)
        {
            uac = Cam.gameObject.AddComponent<UnityEngine.Rendering.Universal.UniversalAdditionalCameraData>();
        }
        uac.renderPostProcessing = true;
        uac.antialiasing = UnityEngine.Rendering.Universal.AntialiasingMode.FastApproximateAntialiasing;
#endif 
    }
    [ContextMenu("SetSkyBox")]
    public void SetSkyBox()
    {
       // if(RenderSettings.skybox!=null)   RenderSettings.skybox.SetFloat("_Exposure", 4);
        RenderSettings.reflectionBounces = 5;
    }

 [SerializeField]  [Range(0,25)] public int index = 0;
    [SerializeField] public Vector3 Dovorot;

    [ContextMenu("Print Quaternion")]
    public void SetTransformFromJSON()
    {
        if (ocObject == null) return;
        if (ocObject.rotation == null) return;
        if (ocObject.rotation.Length > 0)
        {
            transform.rotation = new Quaternion(ocObject.rotation[0], -ocObject.rotation[2], ocObject.rotation[1], ocObject.rotation[3]);
            transform.Rotate(new Vector3(90, 180, 0));
        }
    }
    private void OnValidate()
    {
        SetTransformFromJSON();
    }
}
