 
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Threading;
using Unity.VisualScripting;

#if UNITY_EDITOR                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
using UnityEditor;
using UnityEditor.SceneManagement;
using static UnityEditor.Progress;

#endif

using UnityEngine;
using UnityEngine.Animations;
#if UNITY_PIPELINE_HDRP
using UnityEngine.Rendering.HighDefinition; 
#endif

[ExecuteInEditMode]
public class OCCamerasManager : OCBase
{   
    public List<Camera> cameras= new List<Camera>() ;
    
    void Awake()
    {
         if (Camera.main!=null)
        if ( Camera.main.GetComponent<OCSimpleCameraController>() == null) Camera.main.gameObject.AddComponent<OCSimpleCameraController>().invertY=true;
       if(GetComponent<Animation>()!=null)GetComponent<Animation>().enabled = false;
        
       // transform.SetSiblingIndex(0);
        CreateAnimation();
#if UNITY_EDITOR
        Lightmapping.bakeCompleted += BakeCompleted;
#endif
    }
    private void Update()
    {
        //if (Input.GetKeyDown(KeyCode.Alpha1)) SelectCamera(0);
        //if (Input.GetKeyDown(KeyCode.Alpha2)) SelectCamera(1);
        //if (Input.GetKeyDown(KeyCode.Alpha3)) SelectCamera(2);
        //if (Input.GetKeyDown(KeyCode.Alpha4)) SelectCamera(3);
        //if (Input.GetKeyDown(KeyCode.Alpha5)) SelectCamera(4);
    }
    public void CreateAnimation()
    {

    }
    private void OnEnable()
    {
#if UNITY_EDITOR
        //Subscribe to unity event change selection
        Selection.selectionChanged += OnChangeSelection;
#endif
    }
    
    private void OnDisable()
    {
#if UNITY_EDITOR     
        Lightmapping.bakeCompleted -= BakeCompleted;
        Selection.selectionChanged -= OnChangeSelection;
#endif
    }
    private void OnDestroy()
    {
#if UNITY_EDITOR
        Lightmapping.bakeCompleted -= BakeCompleted;
        Selection.selectionChanged -= OnChangeSelection;
#endif
    }
    public void SetFirstCameraRender()
    {
      
        OCUIControl ocui = FindObjectOfType<OCUIControl>();
        for (int i = 0; i < transform.childCount; i++)
        {
            transform.GetChild(i).GetComponent<Camera>().enabled = false;
            transform.GetChild(i).tag = "Untagged";
        }
        transform.GetChild(0).GetComponent<Camera>().enabled = true;
        transform.GetChild(0).tag = "MainCamera";
        if (ocui != null) ocui.ABimage.sprite = ocui.CurrentCameraSprite;
        if (ocui != null) ocui.ChangeSprite(transform.GetChild(0).name);
        
    }

    void SelectCamera(int id)
    {
        if (id >= transform.childCount) id = transform.childCount - 1;
        for (int i = 0; i < transform.childCount; i++)
        {
            if (i == id)
            {
                transform.GetChild(id).GetComponent<Camera>().enabled = true;
                transform.GetChild(id).tag = "MainCamera";
            }
            else
            {
                transform.GetChild(i).GetComponent<Camera>().enabled = false;
                transform.GetChild(i).tag = "Untagged";
            }
        }
    }
    void OnChangeSelection()
    {
#if UNITY_EDITOR
        int k = -1;
        for (int i = 0; i < transform.childCount; i++)
        {
            if (Selection.activeGameObject == transform.GetChild(i).gameObject) k = i;
            
        }
        if (k >= 0)
            for (int i = 0; i < transform.childCount; i++)
            {

                if (k == i)
                {
                    transform.GetChild(k).GetComponent<Camera>().enabled = true;
                    transform.GetChild(k).tag = "MainCamera";
                    OCUIControl ocui = FindObjectOfType<OCUIControl>();
                    if (ocui != null) ocui.ABimage.sprite = ocui.CurrentCameraSprite;
                    if (ocui != null) ocui.ChangeSprite(transform.GetChild(k).name);
                }
                else
                {
                    transform.GetChild(i).GetComponent<Camera>().enabled = false;
                    transform.GetChild(i).tag = "Untagged";
                }
            }
        //else
        //{
        //    for (int i = 0; i < transform.childCount; i++)
        //        transform.GetChild(i).GetComponent<Camera>().enabled = true;
        //}
#endif
    }
    void BakeCompleted()
    {
#if UNITY_EDITOR

        // RenderAll();
        if (OCBatchScript.isBaking == true)
        {
            EditorUtility.SetDirty(gameObject);
            EditorSceneManager.SaveScene(EditorSceneManager.GetActiveScene());
            Logger.Log("Bake LightMaps Completed "+ EditorSceneManager.GetActiveScene().name);
           
            FindObjectOfType<OneClickSceneManager>(). BuildAndRun();

            Logger.Log("Exit Application");

            EditorApplication.Exit(0);
            Logger.Log("Really Exit Application");

            OCCamerasManager.ReallyQuit();
        }
#endif
    }
    public void AddCamera(OCObject obj, List<OCFBX> objs)
    {
#if UNITY_EDITOR

        Camera Cam = new GameObject().AddComponent<Camera>();
        cameras.Add(Cam);
        float u = FindObjectOfType<OneClickSceneManager>().Units;

        Cam.gameObject.transform.SetParent(transform);
        Cam.gameObject.name = obj.ocname;
        Cam.nearClipPlane = 0.01f;
        Cam.AddComponent<OCCamera>().SetCamera(obj);

#if UNITY_PIPELINE_URP
        UnityEngine.Rendering.Universal.UniversalAdditionalCameraData uac = Cam.GetComponent<UnityEngine.Rendering.Universal.UniversalAdditionalCameraData>();
        if (uac == null)
        {
            uac = Cam.gameObject.AddComponent<UnityEngine.Rendering.Universal.UniversalAdditionalCameraData>();
        }
        uac.renderPostProcessing = true;
        uac.antialiasing = UnityEngine.Rendering.Universal.AntialiasingMode.FastApproximateAntialiasing;
#endif
#if UNITY_PIPELINE_HDRP


        HDAdditionalCameraData data = Cam.gameObject.GetComponent<HDAdditionalCameraData>();
        if (data == null) data = Cam.gameObject.AddComponent<HDAdditionalCameraData>();
        data.antialiasing = HDAdditionalCameraData.AntialiasingMode.SubpixelMorphologicalAntiAliasing;
        // data.
#endif



        OCFBX o = objs.Find(X => X.idx == obj.idx);
        Cam.transform.position = o.transform.position;
        Camera targetCamera = o.GetComponent<Camera>();
        if (targetCamera != null)
        {
            Cam.fieldOfView = targetCamera.fieldOfView;
            Cam.farClipPlane = targetCamera.farClipPlane;
            Cam.focalLength = targetCamera.focalLength;
        }


        //Cam.transform.LookAt(Cam.transform.position + new Vector3(obj.dir[0], obj.dir[2], obj.dir[1]));
        //Cam.transform.rotation=Quaternion.Euler(-Cam.transform.rotation.eulerAngles.x, Cam.transform.rotation.eulerAngles.y, Cam.transform.rotation.eulerAngles.z);
        //Cam.transform.rotation = new Quaternion(obj.rotation[0], obj.rotation[1], obj.rotation[2], obj.rotation[3]);
        //Logger.Log("Quaternion of Camera : "+Cam.transform.rotation.ToString());
        //Logger.Log("Quaternion of 3ds MAX: " + $"[{ obj.rotation[0]}:  {obj.rotation[1]}:{obj.rotation[2]}: {obj.rotation[3]}] ");



        //   Cam.usePhysicalProperties  HZ ?


        if (obj.octype == "Physical" || obj.octype == "VRayPhysicalCamera")// change vertical fov to horizontal
        {
            float f = 2 * Mathf.Atan(Mathf.Tan(obj.fov * Mathf.Deg2Rad * 0.5f) / Cam.aspect) * Mathf.Rad2Deg;
            Cam.fieldOfView = f;
        }
        else

        if (obj.focal_length > 0) 
        { 
        
        Cam.usePhysicalProperties = true;
            Cam.gameObject.tag= "MainCamera";
        }
        if (obj.targetidx != 0)
        {
            o = objs.Find(X => X.idx == obj.targetidx);
            Cam.transform.LookAt(o.transform.position);
                        
        }
#endif
    }





    
    [ContextMenu("RenderAll")]
    public void RenderAll()
    {
        //OneClickSceneManager os = FindObjectOfType<OneClickSceneManager>();
        //string dir = Path.GetDirectoryName(os.Path_Materials);

        //if (!AssetDatabase.IsValidFolder(os.Path_Renders))
        //    AssetDatabase.CreateFolder(dir, Path.GetFileName(os.Path_Renders));

        //List<Camera> cams = GetComponentsInChildren<Camera>().ToList();
        //for (int i = 0; i < cams.Count; i++)
        //{
        //    Logger.Log("XXXXXX!: ");
        //    float start= Time.realtimeSinceStartup;
        //    while (Time.realtimeSinceStartup - start <2) 
        //    {
        //        Logger.Log("BLYAD!: ");
        //        Thread.Sleep(5000);
        //        Logger.Log("SUKA!: "  );
        //        CaptureScreenshot(cams[i], 1920, 1080, os.Path_Renders);
        //    }
        //    Logger.Log("ZZZZZZZZ!: ");
        //}
        

    }
     



public static void ReallyQuit()
    {
        Logger.Log("Try to QUIT SCENE");
        Application.Quit();
        Logger.Log("  !!!");
        var startInfo = new ProcessStartInfo
        {
            FileName = "cmd.exe",
            Arguments = "taskkill /IM Unity.exe /F",
            CreateNoWindow = true,
            UseShellExecute = false
        };

        Process.Start(startInfo);
#if UNITY_EDITOR
        //   Unity
        EditorApplication.Exit(0);
#endif
    }
  
    void CaptureScreenshot(Camera renderCamera, int captureWidth, int captureHeight, string outputFileName)
    {
        
        //     
        RenderTexture renderTexture = new RenderTexture(captureWidth, captureHeight, 24);
        renderCamera.targetTexture = renderTexture;

        //    
        renderCamera.Render();

        //  
        RenderTexture.active = renderTexture;

        //       
        Texture2D screenshot = new Texture2D(captureWidth, captureHeight, TextureFormat.RGB24, false);
        screenshot.ReadPixels(new Rect(0, 0, captureWidth, captureHeight), 0, 0);
        screenshot.Apply();

        //      
        RenderTexture.active = null;
        renderCamera.targetTexture = null;

        //    
        byte[] bytes = screenshot.EncodeToPNG();

        //    
#if UNITY_PIPELINE_HDRP
        string filePath = Path.Combine(Application.dataPath, outputFileName.Substring(7)+"\\"+renderCamera.name+FindObjectOfType<OneClickSceneManager>().ConversionVersion+"_HDRP.png");
#else
        string filePath = Path.Combine(Application.dataPath, outputFileName.Substring(7)+"\\"+renderCamera.name+FindObjectOfType<OneClickSceneManager>().ConversionVersion+"_URP.png");
#endif
        //     PNG
        File.WriteAllBytes(filePath, bytes);
        //OCProductConverter.AddRenderToCurrentProduct(filePath);

        Logger.Log("   " + filePath);
 
    }

    public void RenderCubeMaps()
    {
#if UNITY_EDITOR

        foreach (var item in FindObjectsOfType<ReflectionProbe>())
        {
            
            item.RenderProbe();
            UnityEngine. Debug.Log("Cubemap Rendered: " + item.name);
        }
#endif

    }



} 


                                              