#if UNITY_EDITOR
using UnityEngine;
using System.Collections;
using UnityEditor;


[CustomEditor(typeof(OCSceneControl))]
public class OCInspectorSceneControl : Editor
{ 
    public override void OnInspectorGUI()
    {
        try
        {
            //if (GUILayout.Button("Bake All Reflection Probes"))
            //{
            //    FindObjectOfType<OCVolumeManager>().BakeAllReflectionProbes();
            //}
            DrawDefaultInspector();
            GUILayout.BeginHorizontal();
            //if (GUILayout.Button("Auto Set Lights Multipliers"))
            //{
            //    FindObjectOfType<OCSceneControl>().ControlExposureOfLights();
            //}
            if (GUILayout.Button("Reset All Lights"))
            {
                FindObjectOfType<OCSceneControl>().ResetValues();
            }
            if (GUILayout.Button("Clear LightMaps Baked Data"))
            {
                Lightmapping.Cancel();
                Lightmapping.Clear();
            }
            if (GUILayout.Button("Bake Lighting"))
            {
                Lightmapping.BakeAsync();
            }
            GUILayout.EndHorizontal();
            EditorGUILayout.LabelField(" Scene Units: " + FindObjectOfType<OneClickSceneManager>().Units);
            EditorGUILayout.LabelField(" Lights Total: " + FindObjectOfType<OCLightingManager>().transform.childCount);
            EditorGUILayout.LabelField(" Area: " + FindObjectOfType<OCLightingManager>().Lights.FindAll(X => X.type == 0).Count);
            EditorGUILayout.LabelField(" Spots: " + FindObjectOfType<OCLightingManager>().Lights.FindAll(X => X.type == 4).Count);
            EditorGUILayout.LabelField(" Points: " + FindObjectOfType<OCLightingManager>().Lights.FindAll(X => X.type == 2).Count);
        } catch{ }
        } 
}
#endif