using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;
using UnityEngine.Rendering;

#if UNITY_PIPELINE_HDRP
using UnityEngine.Rendering.HighDefinition;
#endif
public class OCPrefab : MonoBehaviour
{
    [SerializeField] public Light Sun;
    [SerializeField] public Camera Cam;
    [SerializeField] public Volume volume;
#if UNITY_PIPELINE_HDRP
    private VisualEnvironment visualEnvironment;
#endif
    public void ChangeHDRi(string path)
    {
        if (volume == null) volume = GetComponent<Volume>();
        if (volume != null)
        {
#if UNITY_PIPELINE_HDRP
            if (path.Length > 0)
            {

                volume.profile.TryGet(out UnityEngine.Rendering.HighDefinition.HDRISky sky);
                if (sky != null)
                {
#if UNITY_EDITOR
                    sky.hdriSky.Override(AssetDatabase.LoadAssetAtPath<Cubemap>(path));
#endif
                }
                Sun.enabled = false;
                if (volume != null && volume.profile.TryGet(out visualEnvironment))
                {
                    //   VisualEnvironment
                    visualEnvironment.skyType.value = (int)SkyType.HDRI; // :     HDRI
                    visualEnvironment.skyAmbientMode.value = SkyAmbientMode.Static; // :      
                }

        }
        else
            {
                if (volume != null && volume.profile.TryGet(out visualEnvironment))
                {
                    //   VisualEnvironment
                    visualEnvironment.skyType.value = (int)SkyType.PhysicallyBased;
                    Sun.enabled = true;// :      
                }
            }
#endif
        }
    }
}
