using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Unity.VisualScripting;
using UnityEngine;

public class OCProduct
{
    public OCProduct(string name, string descr, string OCvers, string[] videos, string[] images)
    {
        OCPName = name;
        OCPDescription = descr;
        OCVersion = OCvers;
        VideoPreviews = videos;
        ImagePreviews = images;
    }
    [Serialize] public string OCPName;
    [Serialize] public string OCPDescription;
    [Serialize] public string[] OCPKeywords;
    [Serialize] public string OCVersion;
    public List<OCProductContent> files;

    public Dictionary<OCProductStocks, float> OCStockPublishInformation = new Dictionary<OCProductStocks, float>();

    public enum OCProductStocks
    {
        QStock,
        CGTrader,
        TurboSquid,
        Artstation
    }
    [Serialize] public string[] ProductVersion;
    [Serialize] public string[] Products;
    [Serialize] public string[] VideoPreviews;
    [Serialize] public string[] ImagePreviews;

    
    public void SaveProductFile(string path)
    {
        File.WriteAllText(path, JsonUtility.ToJson(this));
    }
    //public float OCRenderVersion;
    //public enum OCEngine
    //{
    //    _3DSMax,
    //    UnityURP,
    //    UnityHDRP,
    //    Unreal,
    //    AbstractProduction
    //} 
    //public enum OCProductPreviewTypes
    //{
    //    SourceImage,PreviewImage,WatermarkedPreviewImage,wireframeImage, PreviewVideo
    //}

    //[Serializable]
    //public abstract class OCProductPreview
    //{
    //    public OCProductPreviewTypes PreviewType;

    //    protected OCProductPreview(OCProductPreviewTypes previewType)
    //    {
    //        PreviewType = previewType;
    //    }
    //}

    //[Serializable]
    //public class OCProductImagePreview : OCProductPreview
    //{
    //    public string PreviewImageUrl;

    //    public OCProductImagePreview(string previewImageUrl)
    //        : base(OCProductPreviewTypes.PreviewImage)
    //    {
    //        PreviewImageUrl = previewImageUrl;
    //    }
    //}

    //[Serializable]
    //public class OCProductFileLink
    //{
    //    public string Link;
    //    public string FileType;

    //    public OCProductFileLink(string link)
    //    {
    //        Link = link;
    //        FileType = Path.GetExtension(link);
    //    }
    //}

    //[Serializable]
    //public class OCProductFileRender
    //{
    //    public string Version;
    //    public string FilePath;

    //    public OCProductFileRender(string version, string filePath)
    //    {
    //        Version = version;
    //        FilePath = filePath;
    //    }
    //}

    //[Serializable]
    //public class StockCostsData
    //{
    //    public OCProductStocks stock;
    //    public int cost;
    //}

    //[Serializable]
    //public class StocksFilesData
    //{
    //    public OCProductStocks stock;
    //    public List<OCProductFileLink> files;
    //}

    //[Serializable]
    //public class FileLinksData
    //{
    //    public OCEngine outputType;
    //    public List<OCProductFileRender> fileRenders;
    //}

    //// JSON DATA IMPORT
    //public List<StockCostsData> stocksCostsData = new List<StockCostsData> ();
    //public List<OCProductPreview> previews = new List<OCProductPreview> ();
    //public List<StocksFilesData> stocksFilesData= new List<StocksFilesData> ();
    //public List<FileLinksData> fileLinksData = new List<FileLinksData>();
    //public string name;

    //// JSON DATA EXPORT
    //public Dictionary<OCProductStocks, int> StocksCosts;
    //public List<OCProductPreview> Previews;
    //public Dictionary<OCProductStocks, List<OCProductFileLink>> StocksFiles;
    //public Dictionary<OCEngine, List<OCProductFileRender>> FileLinks;
    //public string Name;
    //public OCProduct()
    //{
    //    Previews = new List<OCProductPreview>();
    //}
    //public void ConvertListsToDictionaries()
    //{
    //    foreach (var stockCost in stocksCostsData)
    //    {
    //        StocksCosts.Add(stockCost.stock, stockCost.cost);
    //    }

    //    foreach (var stockFiles in stocksFilesData)
    //    {
    //        StocksFiles.Add(stockFiles.stock, stockFiles.files);
    //    }

    //    foreach (var fileLink in fileLinksData)
    //    {
    //        FileLinks.Add(fileLink.outputType, fileLink.fileRenders);
    //    }
    //}



    //OCProduct:
    //{ [ParentOCProduct]
    //[{ChildOCProducts}]
    //[{InputData}] -      
    //[{InpuDtatType}]
    //[ExecuteName][vers][{plugin}][{pluginversion}]

    //[outputfolders]
    //[outformats]
    
    
}