using UnityEngine;
 
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Diagnostics;
using UnityEngine.UIElements;
using UnityEngine.SceneManagement;
using System.Text.RegularExpressions; 
using System;
using UnityEngine.Assertions.Must;
using UnityEngine.UI;
using System.Collections;
using UnityEditor;
using System.Threading.Tasks;

public class OCScreenshotTaker : OCBase
{
    private void Awake()
    {
        if (!Application.isPlaying) return;
        //  OCTools.CheckAndExitIfDuplicate();

        Logger.Ini(OCSM);
        OCTools.CreateTempFolder(OCSM.gameObject.name);
        //  CheckDoubleBuild();
        OCUI.ABimage.enabled = false;
        OCUI.ProgressBar.gameObject.SetActive( false);
       // OCUI.RenderVideo.enabled = false;
        //OCUI.RenderVideo.transform.parent.gameObject.GetComponent<Image>().SetEnabled(false);
        FindCameras();
        Screen.SetResolution((int)600, 380, false); 
        string clearFolder = Path.Combine(Path.GetDirectoryName(ScreenShotPath));
        
        CreateGalleryFromMaxRenders();
        StartCoroutine(SaveFrames());
    }
    
    private IEnumerator SaveFrames()
    {

        while (cframe <= 299)
        {
            if (cframe >= 299)
            {
                Logger.Log("Render Video!");

                RenderVideoAndExit();
            }

            try
            {
                UpdateParam();
            } catch{Logger.Log("OOPS cant change camera and sprite...");}

            if ((cframe < 299))
            {
                TakeScreenshotVideo("Just AB Testing Cameras: " + cframe);
               // Logger.Log("TakeScreenshotVideo: " + cframe);
            }

            cframe++;
            yield return null; 
        
        }
    }
    float param;
    int segment => cframe / 30;
    //         
    void UpdateParam()
    {
        //    (0, 1, 2, ...)
        

        //     
        float progress = (cframe % 30) / 30.0f;

        //   
        // , param    0  1  
        switch (segment)
        {
            case 0:
                //        ,     
                SetCameraTransform(0);
                OCUI.ABimage.fillAmount = 1-progress; //  0  1
                OCUI.ABimage.fillOrigin = 1; // left
                break;
            case 1://        
                LerpCameraTransform(0, 1,progress);
                OCUI.ABimage.fillAmount = 0;//    
                 
                break;
            case 2:
                OCUI.ABimage.fillAmount = progress;//  
             //   OCUI.ABimage.sprite = OCUI.Sprites[1]; //   
                SetCameraTransform(1);
                 
                break;
            case 3:
                SetCameraTransform(1);
                OCUI.ABimage.fillAmount = 1 - progress;//     
                OCUI.ABimage.fillMethod= UnityEngine.UI.Image.FillMethod.Radial360;//     
                break; 
            case 4:
                LerpCameraTransform(1,2,progress);
                OCUI.ABimage.fillAmount = 0;
                break;
            case 5:
                OCUI.ABimage.fillAmount = progress;
          //      OCUI.ABimage.sprite = OCUI.Sprites[2];
                OCUI.ABimage.fillMethod= UnityEngine.UI.Image.FillMethod.Vertical;//     

                SetCameraTransform(2);
                break; 
            case 6:
                OCUI.ABimage.fillAmount = 1-progress;
            //    OCUI.ABimage.sprite = OCUI.Sprites[2];
                SetCameraTransform(2);
                break;
            case 7:
                LerpCameraTransform(2, 3, progress);
                OCUI.ABimage.fillAmount = 0;
                break;
            case 8:
                OCUI.ABimage.fillAmount = progress;
             //   OCUI.ABimage.sprite = OCUI.Sprites[3];
                SetCameraTransform(3);
                break;
            case 9:
                LerpCameraTransform(3, 3, progress);
                OCUI.ABimage.fillAmount = 0;
                break;
            case 10:
                OCUI.ABimage.fillAmount = 1;
               // OCUI.ABimage.sprite = SpritesToRender[0];
                SetCameraTransform(3);
                break; case 11:
                OCUI.ABimage.fillAmount = 1;
               // OCUI.ABimage.sprite = SpritesToRender[1];
                SetCameraTransform(3);
                break;case 12:
                OCUI.ABimage.fillAmount = 1;
               // OCUI.ABimage.sprite = SpritesToRender[2];
                SetCameraTransform(3);
                break;case 13:
                OCUI.ABimage.fillAmount = 1;
               // OCUI.ABimage.sprite = SpritesToRender[3];
                SetCameraTransform(3);
                break;
            default:
                param = 0; //      
                break;
        }
    }
    void CheckDoubleBuild()
    {
#if UNITY_EDITOR
       
#else
         

        //if (File.Exists(Path.GetTempPath() + "DoubleBuild.txt"))
        //{
        //    File.Delete(Path.GetTempPath() + "DoubleBuild.txt");
        //    Logger.Log("DoubleBuild");
        //    Application.Quit();

        //    DestroyImmediate(this.gameObject);
        //}
        //else
        //{
        //    Logger.Log("DoubleBuild File Created");
        //    File.Create(Path.GetTempPath() + "DoubleBuild.txt");
        //}
#endif
    }
    private void SetCameraTransform(int CurCamera)
    {
        if (CurCamera >= Cameras.Count) CurCamera = 0;
         if(Camera.main==null)
        {
            Cameras[0].enabled = true;
            Cameras[0].tag= "MainCamera";

        }
        Camera.main.transform.position = Cameras[CurCamera].transform.position;
        Camera.main.transform.rotation = Cameras[CurCamera].transform.rotation;
        Camera.main.fieldOfView = Cameras[CurCamera].fieldOfView;
    }
    private void LerpCameraTransform(int Acamera, int Bcamera, float _lerp)
    {
        if (Acamera >= Cameras.Count) Acamera = 0;
        if (Bcamera >= Cameras.Count) Bcamera = 0;

        Camera.main.transform.position = Vector3.Lerp(Cameras[Acamera].transform.position, Cameras[Bcamera].transform.position, _lerp);
      //  Cameras[0].transform.position = Vector3.Lerp(Cameras[Acamera].transform.position, Cameras[Bcamera].transform.position, _lerp);
        Camera.main.transform.rotation = Quaternion.Lerp(Cameras[Acamera].transform.rotation, Cameras[Bcamera].transform.rotation, _lerp);
     //   Cameras[0].transform.rotation = Quaternion.Lerp(Cameras[Acamera].transform.rotation, Cameras[Bcamera].transform.rotation, _lerp);
        Camera.main.fieldOfView = Mathf.Lerp(Cameras[Acamera].fieldOfView, Cameras[Bcamera].fieldOfView, _lerp);
    }
    //   
    int totalFrames => Cameras.Count * maxframes; //  
   
    OCUIControl _OCUI;
    OCUIControl OCUI
    {
        get
        {
            if (_OCUI == null)
            {
                _OCUI = FindObjectOfType<OCUIControl>();
            }
            return _OCUI;
        }
    }
    OneClickSceneManager _OCSM;
    OneClickSceneManager OCSM
    {
        get
        {
            if (_OCSM == null)
            {
                _OCSM = FindObjectOfType<OneClickSceneManager>();
            }
            return _OCSM;
        }
    }


    public int maxframes = 30;
    public int cframe = -1;
    float lerp = 0;
    [ContextMenu("Tools/Take Screenshot %#s")] //  Ctrl+Shift+S (Cmd+Shift+S  Mac)  
    public void TakeScreenshotOFUnityCamera(int CurCamera)
    {

        string ScreenShotPath = Path.Combine(FindObjectOfType<OneClickSceneManager>().Path_Renders, Cameras[CurCamera].name + OCSM.ConversionVersion + ".png");
        // CheckPreviousVersionOfFileAndDelete(ScreenShotPath);
        ScreenCapture.CaptureScreenshot(ScreenShotPath);
        Logger.Log("Screenshot saved to: " + Cameras[CurCamera].name + "  " + ScreenShotPath);

    }
    private GUIStyle guiStyle = new GUIStyle();
    public static void CheckPreviousVersionOfFileAndDelete(string path)
    {
        //if (File.Exists(path))
        //{
        //    //           
        //    Regex regex = new Regex(@"\[(\d+)\]\.png$", RegexOptions.IgnoreCase);

        //    //      
        //    Match match = regex.Match(path);

        //    if (match.Success)
        //    {
        //        //     
        //        int fileVersion = int.Parse(match.Groups[1].Value);

        //        //     Logger.Version
        //        // ,  Logger.Version -   /
        //        if (fileVersion < Logger.Version - 1)
        //        {
        //            File.Delete(path);
        //            Logger.Log($" {path} ,     ({fileVersion})    ({Logger.Version}).");
        //        }
        //        else
        //        {
        //            Logger.Log($" {path}  ,     ({fileVersion})      ({Logger.Version}).");
        //        }
        //    }
        //}
        //else
        //{
        //    Logger.Log($" {path}  .");
        //}
    }
    void OnGUI()
    {
        try {
            //      Full HD (1920x1080)
            float relativeFontSize = Screen.height * 0.04f; //  4%  
            guiStyle.fontSize = (int)relativeFontSize;
            guiStyle.normal.textColor = Color.white;

            //  
            float backgroundHeight = 160; //  
            float backgroundWidth = Screen.width - 20; //  
            float backgroundMargin = 5; //     

            //  
            GUI.Box(new Rect(10, Screen.height - backgroundHeight - backgroundMargin, backgroundWidth, backgroundHeight), "");

            //  
            GUI.Label(new Rect(15, Screen.height - 155, 200, 50), $@"segment: {segment} Sprites:{SpritesToRender.Count} RenderTime: {(Time.realtimeSinceStartup.ToString("00.0sec"))}", guiStyle);
            GUI.Label(new Rect(15, Screen.height - 105, 200, 50), $@"SceneName: {SceneManager.GetActiveScene().name}: LightMaps? : {FindObjectOfType<OneClickSceneManager>().isLM} ", guiStyle);
            GUI.Label(new Rect(15, Screen.height - 55, 200, 50), "Max Export Time: " + Summ + Logger.Status + $@" FramesToRender: {GalleryFramesLenghtPerFile}", guiStyle);
            if (Cameras.Count > 0) GUI.Label(new Rect(955, Screen.height - 155, 200, 50), "Camera: " + Camera.main.ToString(), guiStyle);
        }
        catch
        {

        }
    }

   
    string _ScreenShotPath;
    string ScreenShotPath
    {
        get
        {
              
            _ScreenShotPath = Path.Combine(OCTools.GetTempFolder(OCSM.gameObject.name), cframe.ToString("0000") + ".png"); 
           
            return _ScreenShotPath;
        }
    }
    public void TakeScreenshotVideo(string AdditionalLog)
    {

        string directoryPath = OCTools.GetTempFolder(OCSM.gameObject.name); //    

        //Logger.Log(AdditionalLog + " : cframe:" + cframe);

        // ,   
        if (!Directory.Exists(directoryPath))
        {
            Directory.CreateDirectory(directoryPath); //  ,    
        }
        ScreenCapture.CaptureScreenshot(Path.GetFullPath( ScreenShotPath));
        if (!File.Exists(Path.GetFullPath(ScreenShotPath)))
        {
           
            ScreenCapture.CaptureScreenshot(Path.GetFullPath(ScreenShotPath));
           
        }
        if (cframe % 30 == 0) // ,   cframe  30
        {
            Logger.Add("Screenshot saved to: " + "  " + ScreenShotPath);
        }
    }

    float timer = 0;
    List<Camera> Cameras = new List<Camera>();
    int CurrentCamera = 0;
    
   
    private void FindCameras()
    {
        Cameras = new List<Camera>();
        for (int i = 0; i < FindObjectOfType<OCCamerasManager>().transform.childCount; i++)
        {
            Cameras.Add(FindObjectOfType<OCCamerasManager>().transform.GetChild(i).GetComponent<Camera>());
        }
        
       // TurnCameraOn(0, OCUI.Sprites[0], 1);
    }
    
    public void TurnCameraOn(int id,Sprite sprite, float fillAmount)
    {
        for (int i = 0; i < Cameras.Count; i++)
        {
            if (i == id)
            {
                Cameras[i].enabled = true; 
              //  OCUI.ABimage.sprite = sprite;
                OCUI.ABimage.fillAmount = fillAmount;
               // OCUI.ABimage.enabled = true;
                Cameras[i].tag = "MainCamera";
            }
            else Cameras[i].enabled = false;

        }
    }
    int load = -1;
    bool isRender=false;
    public static string FFMPEGG = @"C:\Program Files\renderfin\assets\ffmpeg.exe";
   public void RenderVideoAndExit()
    {
        if (isRender == false) isRender = true;
        else return;
        string v = Logger.Version + "\n" + Application.unityVersion + "\n" + OCSM.SUKARP;

      
        Logger.Log("Renders Parh: "+ OCSM.Path_Renders);
        CreateVideo(ScreenShotPath,   OCSM.OCRender.OutputProductFolder + "//0000.png" ,true,"/C");
        CreateProduct();
         Logger.Log("BakeCompleted! Application Quit!");
        //if (!Application.isEditor)
        //{]
        tryToQuit = true;
        Application.Quit();
#if UNITY_EDITOR
#else
        Logger.Log("Try to Kill Unity Process!!!!");
         KillUnityProcess();
        KillUnityProcess();
          KillUnityProcess();
        //KillUnityProcess();
        //KillUnityProcess();
         Logger.Log("Try to Really QUIT!!!!");

         OCCamerasManager.ReallyQuit();
#endif
    }
    public bool tryToQuit = false;
    public void CreateGalleryFromMaxRenders()
    {
        
        // Load List Of First Camera Render
        for (int i = 0; i < Cameras.Count; i++)
        {
        //LoadImageAsSprite(Path.Combine( OCSM.Path_Renders, Cameras[i].name+"_max.png"));
        //LoadImageAsSprite(Path.Combine(OCSM.Path_Renders, Cameras[i].name+"_vp.png"));
        //LoadImageAsSprite(Path.Combine(OCSM.Path_Renders, Cameras[i].name+"_wire.png"));
        } 
       // string Path_OCBackgroundImageForBuilds = @"C:\OneClickUnityDefaultProjects\OCURP21 +\Assets\OneClickImport\Textures\Ocbackground0000.jpg";
        //LoadImageAsSprite(Path_OCBackgroundImageForBuilds);


    }
    Sprite SummarySprite;
    private int GalleryFramesLenghtPerFile = 30;
    
    public static void KillUnityProcess()
    {
        ProcessStartInfo processStartInfo = new ProcessStartInfo
        {
            FileName = "cmd.exe",
            Arguments = "/c taskkill /IM Unity.exe /F",
            UseShellExecute = false,
            CreateNoWindow = true
        };

        Process process = new Process
        {
            StartInfo = processStartInfo
        };

        process.Start();
    }
    public  void CreateVideo(string imagesPath, string outputPath,  bool checkSequence, string param)
    {
        try
        {
            string fileExtension = Path.GetExtension(imagesPath);

            if (checkSequence)
            {
                VideoHelper.CheckVideoFrames(imagesPath, cframe);
                VideoHelper.FillMissingVideoFrames(imagesPath);
            }
       string imagesPath2 = Path.GetFullPath(imagesPath);
        imagesPath = Path.GetDirectoryName(imagesPath2);

        outputPath = Path.GetFullPath(outputPath);
        outputPath = Path.GetDirectoryName(outputPath);
            String arg;
            if (!checkSequence)
            {
                imagesPath = imagesPath2.Substring(0, imagesPath2.Length - 8);
                arg = param+" \"\"" + FFMPEGG + "\"" + " -framerate 30 -i " + "\"" + imagesPath + "%4d" + fileExtension + "\" -c:v libx264 -pix_fmt yuv420p \"" + outputPath + "\\" + OCSM.gameObject.name + ".mp4\" -y \"";// 2> C:\\1\\videoGeneratorLog.log";

            }
            else
            arg = param + " \"\"" + FFMPEGG + "\""+ " -framerate 30 -i " + "\""+imagesPath + "\\%4d"+ fileExtension + "\" -c:v libx264 -pix_fmt yuv420p \"" + outputPath + "\\" + OCSM.gameObject.name+ ".mp4\" -y \"";// 2> C:\\1\\videoGeneratorLog.log";
        
            Logger.Log("CreateVideo: " + imagesPath + " " + outputPath + " " + FFMPEGG);
           
            Logger.Log("arg: " + arg);

            Process.Start("cmd.exe", arg).WaitForExit(1000);
        }
        catch( Exception ex) { 
            Logger.Log("VideoPreview is NOT Created: "+ex.Message );
        };

    }
    public async void CreateProduct()
    {

        OCProduct prod = new OCProduct(OCSM.name, "Description", OCSM.ConversionVersion, new string[] { OCSM.OCRender.OutputProductFolder + "\\" + OCSM.gameObject.name + ".mp4", "" },
            new string[] { "", "" });



        string Ppath = Path.Combine(OCSM.OCRender.OutputProductFolder, OCSM.name + "_product.json");
        Logger.Log("Product Created: " + Ppath);

        prod.SaveProductFile(Ppath);

        for (int i=0; i< cframe; i++)
            if(i % 30==0)
        {
            string rpath = Path.GetFullPath(Path.Combine(OCSM.OCRender.OutputProductFolder, (i ).ToString("0000") + ".png"));
            Logger.Log($"Copy Render From:{rpath} to {Path.GetFullPath(ScreenShotPath)}");
            if (!File.Exists(rpath))
                File.Copy(Path.Combine(OCTools.GetTempFolder(OCSM.gameObject.name), i.ToString("0000") + ".png"),rpath, true);
            if (File.Exists(rpath)) Logger.Add("File Succesfully copyed!");
        }


        await OCMessagetoRF.SendMessageAsync("Product Created: " + OCSM.name + OCSM.ConversionVersion, Ppath);
    }
    public static void DeleteFilesRecursively(string directoryPath)
    {
        // ,    
        if (!Directory.Exists(directoryPath))
        {
            return;
        }
         
        string[] files = Directory.GetFiles(directoryPath);
        foreach (string file in files)
        {
            File.Delete(file);
        }
        Logger.Log("Recursive try to delete Files of video Preview!");

        //        
        string[] directories = Directory.GetDirectories(directoryPath);
        int counter = 0;
        foreach (string dir in directories)
        {
            counter++;
            DeleteFilesRecursively(dir);
        }
        Logger.Log("Recursive Deleting Completed. Total files deleted: " + counter);

    }
    public float GetMaxLog()
    {
       string MaxLogFile =  Path.Combine( Application.dataPath, OCSM.gameObject.name,OCSM.gameObject.name + ".txt");
        if (System.IO.File.Exists(Path.GetFullPath( MaxLogFile)))
        { 
            ParseAndSumTimes(MaxLogFile);
        }
        else
        {
            return 0;
        }
        return 0;
    }
    public static int Summ;
    public static void ParseAndSumTimes(string input)
    {
        //     
       
        int meshesTime = 0, bakedMapsTime = 0, origMapsTime = 0, fbxTime = 0;
        string []str = File.ReadAllLines(input);
        string pattern = "baked maps";
        foreach (string line in str)
        {
            int patternIndex = line.IndexOf(pattern);
            if (patternIndex >= 0)
            {
                // -6   , +5  ,  11  ( "XX:XX")
                string timeString = line.Substring(patternIndex - 6, 5);

                //  
                string[] timeParts = timeString.Split(':');
                int minutes = int.Parse(timeParts[0]);
                int seconds = int.Parse(timeParts[1]);

                bakedMapsTime = minutes * 60 + seconds;
                break; //     
            }
        }
        

        Summ = meshesTime + bakedMapsTime + origMapsTime + fbxTime;
        Logger.Log(($@"meshes: {meshesTime} sec. bakedMaps: {bakedMapsTime} sec. origMaps: {origMapsTime} sec. fbx: {fbxTime} sec."));
        Logger.Log(($"Max Render Total Time: {Summ} sec."));
    }
    public List<Sprite> SpritesToRender = new List<Sprite>();

    public void LoadImageAsSprite(string path)
    {
        Texture2D texture = LoadTexture(path);
        if (texture != null)
        {
            Sprite newSprite = Texture2DToSprite(texture);
            SpritesToRender.Add(newSprite);
        }
        else
        {
            Logger.Log("    : " + path);
        }
    }

    private Texture2D LoadTexture(string path)
    {
        Texture2D texture = null;
        byte[] fileData;

        if (System.IO.File.Exists(path))
        {
            fileData = System.IO.File.ReadAllBytes(path);
            texture = new Texture2D(2, 2);
            texture.LoadImage(fileData); //    
        }
        return texture;
    }

    private Sprite Texture2DToSprite(Texture2D texture)
    {
        return Sprite.Create(texture, new Rect(0.0f, 0.0f, texture.width, texture.height), new Vector2(0.5f, 0.5f), 100.0f);
    }
}