using System;
using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;
using UnityEngine.Windows;
using System.IO;
#if UNITY_EDITOR
using UnityEditor.Build.Reporting;
#endif
[ExecuteInEditMode]
public static class OCStartBuild  
{
    public static bool isBuileded=false;
    public static void StartBuild(OneClickSceneManager ocsm)
    {
#if UNITY_EDITOR
        if (isBuileded == true) return;
        //  
        BuildPlayerOptions buildPlayerOptions = new BuildPlayerOptions
        {
            scenes = new[] { UnityEditor.SceneManagement.EditorSceneManager.GetActiveScene().path},
            locationPathName = ocsm.buildPath,
            target = BuildTarget.StandaloneWindows64,
            options = BuildOptions.AutoRunPlayer
        };
        try
        {
            if (BuildPipeline.isBuildingPlayer)
            {
                Logger.Log("BuildPipeline.isBuildingPlayer");
                return;
            }
            Logger.Log("Start Build: " + ocsm.buildPath + "\n" + buildPlayerOptions.ToString());

            if (System.IO.Directory.Exists(Path.GetDirectoryName(ocsm.buildPath)))
                {
                 System.IO.Directory.Delete(Path.GetDirectoryName(ocsm.buildPath), true);
                }
            System.IO.Directory.CreateDirectory(Path.GetDirectoryName(ocsm.buildPath));
            
            BuildReport report = BuildPipeline.BuildPlayer(buildPlayerOptions);
            BuildSummary summary = report.summary;

            if (summary.result == BuildResult.Succeeded)
            {
                Logger.Log("Build succeeded: " + summary.totalSize + " bytes");
            }

            if (summary.result == BuildResult.Failed)
            {
                Logger.Log("Build failed: " +summary.totalErrors + " errors OutputPath: "+summary.outputPath+" ");;
            }


        }
        catch (Exception ex)
        {
            Logger.Log("Error Build: " + ex.Message);
        }

       // OCTools.KillUrSelfProcess();
#endif
    }
}
