﻿using System.Collections.Generic; 
using UnityEngine;
using System.IO; 
using System;
using System.Diagnostics;
using System.Linq;

public static class OCTools 
{
    private static readonly HashSet<string> excludedFolders = new HashSet<string>
    {
        "Assets/OneClickImport",
        "Assets/Settings"
        // Äîáàâüòå ïóòè ê ïàïêàì, êîòîðûå íå íóæíî óäàëÿòü
    };
    public static void StartCustomProcess(string exePath, string arguments)
    {
        try
        {
            ProcessStartInfo processStartInfo = new ProcessStartInfo
            {
                FileName = exePath,
                Arguments = arguments,// + " 2 > \"C:/1/outCustomProcess.txt\""),
                UseShellExecute = true // Èñïîëüçóåòñÿ äëÿ çàïóñêà ïðîöåññà ÷åðåç îáîëî÷êó ñèñòåìû
            };

            Process process = new Process
            {
                StartInfo = processStartInfo
            };

            process.Start();
        }
        catch (Exception ex)
        {
            Logger.Log("Îøèáêà ïðè çàïóñêå ïðîöåññà: " + ex.Message);
        }
    }
    public static void KillUrSelfProcess()
    {
        try
        {
            // Ïîëó÷àåì òåêóùèé ïðîöåññ
            Process currentProcess = Process.GetCurrentProcess();

            // Âûâîäèì èíôîðìàöèþ î ïðîöåññå
            Logger.Log("Ïðîöåññ: " + currentProcess.ProcessName);
            Logger.Log("ID ïðîöåññà: " + currentProcess.Id);

            // Çàâåðøàåì ïðîöåññ
            currentProcess.Kill();
        }
        catch (Exception ex)
        {
            // Îáðàáîòêà èñêëþ÷åíèé
            Logger.Log("Îøèáêà: " + ex.Message);
        }
    }
   
    public static string GetTempFolder(string folderName)
    { 
        return Path.Combine(Path.GetTempPath(), folderName); 
    }
    public static void CreateTempFolder(string folderName)
    {
        try
        {
            // Ïîëó÷àåì ïóòü ê âðåìåííîé ïàïêå Windows
            string tempPath = Path.GetTempPath();

            // Ñîçäàåì ïîëíûé ïóòü ê íîâîé ïàïêå
            string newFolderPath = Path.Combine(tempPath, folderName);

            // Ïðîâåðÿåì, ñóùåñòâóåò ëè óæå òàêàÿ ïàïêà
            if (!Directory.Exists(newFolderPath))
            {
                // Ñîçäàåì ïàïêó, åñëè îíà íå ñóùåñòâóåò
                Directory.CreateDirectory(newFolderPath);
                Logger.Log("Ïàïêà ñîçäàíà: " + newFolderPath);
            }
            else
            {
                Logger.Log("Ïàïêà óæå ñóùåñòâóåò: " + newFolderPath);
            }
        }
        catch (IOException ioEx)
        {
            Logger.Log("Îøèáêà ââîäà-âûâîäà: " + ioEx.Message);
        }
        catch (System.Exception ex)
        {
            Logger.Log("Îøèáêà: " + ex.Message);
        }
    }
    private static void CleanDirectory(string directoryPath)
    {
#if UNITY_EDITOR

        //foreach (string directory in Directory.GetDirectories(directoryPath))
        //{
        //    string relativePath = "Assets" + directory.Replace(Application.dataPath, "").Replace("\\", "/");

        //    if (!excludedFolders.Contains(relativePath))
        //    {
        //        CleanDirectory(directory); // Ðåêóðñèâíî î÷èùàåì âëîæåííûå ïàïêè

        //        FileUtil.DeleteFileOrDirectory(directory); // Óäàëÿåì ïàïêó
        //        FileUtil.DeleteFileOrDirectory(directory + ".meta"); // Óäàëÿåì ñîîòâåòñòâóþùèé .meta ôàéë
        //    }
        //}

        // Ïîõîæèé ïðîöåññ äëÿ ôàéëîâ, åñëè íóæíî
#endif
    }

    public static void ClearSceneObjects()
    {
        //foreach (var gameObject in SceneManager.GetActiveScene().GetRootGameObjects())
        //{
        //    GameObject.DestroyImmediate(gameObject);
        //}
    }
    public static string CheckClone(string clone)
    {
        if (clone.EndsWith("(Clone)")) clone = clone.Substring(0, clone.Length - 7);
        return clone;
    }
    public static void DeleteBuildsInDirectory(string directoryPath)
    {
        //foreach (var directory in Directory.GetDirectories(directoryPath))
        //{
        //    if (Path.GetFileName(directory) == "Builds")
        //    {
        //        Directory.Delete(directory, true); // Deleting Builds folder and its contents
        //        File.Delete(directory + ".meta"); // Deleting meta file of the folder
        //    }
        //    else
        //    {
        //        DeleteBuildsInDirectory(directory); // Recursive call for subdirectories
        //    }
        //}
    }
    /// <summary> Super Function For Succes? </summary>
    public static string GetUnityPath(string str)
    {
        int k = -1;
        k = str.IndexOf("Assets");
        if(k==-1) return str;
        return str.Substring(k);
    }
    public static string GetFirstFolder(string path)
    {
        // Ðàçäåëÿåì ïóòü ïî îáðàòíîìó ñëåøó (äëÿ Windows)
        var parts = path.Split('\\');

        // Âîçâðàùàåì ïåðâóþ ïàïêó, åñëè îíà ñóùåñòâóåò
        return parts.Length > 1 ? parts[0] : null;
    }
    public static bool isNotClear(Color c)
    {
        if(c.r>0 && c.g>0 && c.b>0) return true;
        return false;
    }
    public static bool isNotClear(Color c, float sum)
    {
        if (c.r > sum && c.g > sum && c.b > sum) return true;
        return false;
    }
    public static Color ClampColor(Color clr,float clamp)
    {
        return new Color(Mathf.Clamp(clr.r, 0, clamp), Mathf.Clamp(clr.g, 0, clamp), Mathf.Clamp(clr.b, 0, clamp), Mathf.Clamp(clr.a, 0, clamp));
    }
    public static void AddLineIfNotExists(string filePath, string lineToAdd)
    {
        // Проверка, существует ли файл
        if (!File.Exists(filePath))
        {
            // Создание файла и добавление строки
            File.WriteAllText(filePath, lineToAdd + Environment.NewLine);
            return;
        }

        // Чтение всех строк файла
        string[] lines = File.ReadAllLines(filePath);

        // Проверка, содержит ли файл указанную строку
        if (!lines.Contains(lineToAdd))
        {
            // Добавление строки в файл
            File.AppendAllText(filePath, lineToAdd + Environment.NewLine);
        }
    }
}
