using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Rendering;

public class OCVolumeControlPlayMode : MonoBehaviour
{
    public string labelText = "Your Text Here";
    public int baseFontSize = 16; //      
    public Vector2 baseResolution = new Vector2(1920, 1080); // ,      

    void OnGUI()
    {
        //   
        float horizontalRatio = Screen.width / baseResolution.x;
        float verticalRatio = Screen.height / baseResolution.y;
        float ratio = Mathf.Min(horizontalRatio, verticalRatio);

        //  GUIStyle  
        GUIStyle labelStyle = new GUIStyle(GUI.skin.label);
        labelStyle.fontSize = (int)(baseFontSize * ratio); //   

        //   
        Vector2 textSize = labelStyle.CalcSize(new GUIContent(labelText));

        //  
        string str = "";
        if (GetComponent<Volume>()?.profile != null) str = name;
        GUI.Label(new Rect((Screen.width - textSize.x) / 2, (Screen.height - textSize.y) / 2, textSize.x, textSize.y),str , labelStyle);
    }
}
