using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEditor;
using UnityEngine;

#if UNITY_PIPELINE_HDRP
using UnityEngine.Rendering.HighDefinition;
using UnityEngine.SocialPlatforms;
#endif
public class OCVrayLight : MonoBehaviour
{
    public float selfIllumMult = 1;
#if UNITY_PIPELINE_HDRP
    private HDAdditionalLightData _lightData;
    public HDAdditionalLightData lightData
    {
        get
        {
            if (_lightData == null)
            {
                _lightData = gameObject.GetComponent<HDAdditionalLightData>();
            }
            return _lightData;
        }
    }
#endif



    [HideInInspector] public string ocname;
    [HideInInspector] public int type;
    [HideInInspector] public bool on;
    [HideInInspector] public float color_temperature;
    [HideInInspector] public Color color;
    [HideInInspector] public float multiplier;
    [HideInInspector] public float size0;
    [HideInInspector] public float size1;
    [HideInInspector] public float size2;
    [HideInInspector] public float sizeLenght;
    [HideInInspector] public float sizeWidth;
    [HideInInspector] public bool castShadows;
    [HideInInspector] public bool DoubleSided;
    [HideInInspector] public bool invisible;
    [HideInInspector] public Texture2D texmap;
    [HideInInspector] public bool texmap_on;
    [HideInInspector] public Vector3 position;
    [HideInInspector] public Vector3 scale;
    [HideInInspector] public Vector3 rotation;
    [HideInInspector] public Light l;
    
    // Update is called once per frame
    void Update()
    {
       
    }
    [ContextMenu ("test Light")]
    void TestLight()
    {
#if UNITY_PIPELINE_HDRP
        HDAdditionalLightData lightData = gameObject.GetComponent<HDAdditionalLightData>();
        if (lightData != null)
        {
            lightData.intensity = 3;
            
        }
#endif
    }  
    
    [ContextMenu ("test Physics")]
    public void TestPhys()
    {
        RaycastHit hit;
        if (Physics.Raycast(transform.position+transform.forward*0.33f, transform.forward, out hit))
        {
           // Debug.Log(hit.transform.name);
            Light l = GetComponent<Light>();
            if (l != null)
            {
                l.range = hit.distance * 2.2f;
                l.range = Mathf.Clamp(l.range, 1, 150);
            }
             
        }
    }
}
